MPIR_HOME = /home/lusk/mpich
MPI_HOME  = /home/lusk/mpich
DEVICE_INCLUDE = $MPIR_HOME/include/mpid.h
ITOOLSDIR  = /home/gropp/tools.n
DDIR       = $(ITOOLSDIR)/libs/libsg/$(ARCH)/
DEVICE_MAIN = $(DDIR)/cmain.o
DEVICE_MAINF = $(DDIR)/fmain.o
DEVICE_LIB = $(DDIR)/toolsp4.a $(DDIR)/tools.a $(DDIR)/system.a $(CLIB)
#		/usr/local/p4-1.3/SUN/lib/libp4.a
CFLAGS = -g -I$(MPIR_HOME)/include -I../mpid/chameleon -I/home/gropp/tools.n
FFLAGS = '-qdpc=e' 
CC = cc
CLINKER = cc # -Qoption ld -y_MPIR_Error
LIBS = $(MPI_HOME)/lib/$(ARCH)/libmpi.a $(DEVICE_LIB)
EXECS = basictest typetest grouptest first second third fourth fifth

BOPT    = g
PROFILE = 
include $(ITOOLSDIR)/bmake/$(ARCH).$(BOPT)$(PROFILE)
include $(ITOOLSDIR)/bmake/$(ARCH)
include $(ITOOLSDIR)/bmake/$(ARCH).$(COMM)

default: first second third fourth fifth secondf
#default:  nucleimpi

basictest: basictest.o ../include/mpir.h ../lib/$(ARCH)/libmpi.a
	$(CLINKER) -g -o basictest $(DEVICE_MAIN) basictest.o $(LIBS)

typetest: typetest.o ../include/mpir.h ../lib/$(ARCH)/libmpi.a
	$(CLINKER) -g -o typetest typetest.o $(LIBS)

grouptest: grouptest.o ../include/mpir.h ../lib/$(ARCH)/libmpi.a
	$(CLINKER) -g -o grouptest grouptest.o $(LIBS)

first: first.o ../include/mpir.h ../lib/$(ARCH)/libmpi.a
	$(CLINKER) -g -o first $(DEVICE_MAIN) first.o $(LIBS)

second: second.o ../include/mpir.h ../lib/$(ARCH)/libmpi.a
	$(CLINKER) -g -o second $(DEVICE_MAIN) second.o $(LIBS)

secondf: secondf.o ../include/mpir.h ../lib/$(ARCH)/libmpi.a
	$(FLINKER) -g -o secondf  $(DEVICE_MAINF) secondf.o $(LIBS)

nucleimpi: nucleimpi.o ../include/mpir.h ../lib/$(ARCH)/libmpi.a
	$(FLINKER) -g -o nucleimpi  $(DEVICE_MAINF) nucleimpi.o \
	libgen.a libnuc.a libutil.a $(BLAS) $(LIBS)

third: third.o ../include/mpir.h ../lib/$(ARCH)/libmpi.a
	$(CLINKER) -g -o third $(DEVICE_MAIN) third.o $(LIBS)

fourth: fourth.o ../include/mpir.h ../lib/$(ARCH)/libmpi.a
	$(CLINKER) -g -o fourth $(DEVICE_MAIN) fourth.o $(LIBS)

fifth: fifth.o ../include/mpir.h ../lib/$(ARCH)/libmpi.a
	$(CLINKER) -g -o fifth $(DEVICE_MAIN) fifth.o $(LIBS)

sixth: sixth.o ../include/mpir.h ../lib/$(ARCH)/libmpi.a
	$(CLINKER) -g -o sixth $(DEVICE_MAIN) sixth.o $(LIBS)

coll1: coll1.o ../include/mpir.h ../lib/$(ARCH)/libmpi.a
	$(CLINKER) -g -o coll1 $(DEVICE_MAIN) coll1.o $(LIBS)

.c.o:
	$(CC) $(CFLAGS) -c $*.c

clean:
	/bin/rm -f *.o *~ PIa* $(EXECS)
