C/*
C *  
C *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
C *      All rights reserved.  See COPYRIGHT in top-level directory.
C */
C
C/* user include file for MPI programs, with no dependencies */
C
C/* assorted defined constants */
C
C/* return codes */
       integer MPI_OK, MPI_SUCCESS, MPI_EXAUSTED, MPI_INVALID_TAG
       parameter (MPI_OK=0,MPI_SUCCESS=0,MPI_EXAUSTED=1,
     $      MPI_INVALID_TAG=2)
C
       integer MPI_UNDEFINED, MPI_UNDEFINED_RANK
       parameter (MPI_UNDEFINED = (-32766),
     $      MPI_UNDEFINED_RANK=MPI_UNDEFINED)
C
C       
C/* Topology types */
C#define MPI_GRAPH  0
C#define MPI_CART   1
C
C/* communication modes */
C       integer MPI_STANDARD, MPI_READY, MPI_SYNCHRONOUS, MPI_RECV 
C       parameter (MPI_STANDARD = 0, MPI_READY = 1, MPI_SYNCHRONOUS = 2,
C     $          MPI_RECV = 3)
C
       integer  MPI_BOTTOM, MPI_PROCNULL
       parameter ( MPI_BOTTOM = 0, MPI_PROCNULL = (-2) )
C
      INTEGER MPI_PERSISTENT, MPI_EPHEMERAL
      PARAMETER( MPI_PERSISTENT = 0, MPI_EPHEMERAL = 1)
C
      INTEGER MPI_STATUS_SOURCE, MPI_STATUS_TAG, MPI_STATUS_COUNT
      PARAMETER(MPI_STATUS_SOURCE=2,MPI_STATUS_TAG=3,
     $     MPI_STATUS_COUNT=1)
      INTEGER MPI_STATUS_SIZE
      PARAMETER (MPI_STATUS_SIZE=3)
C     
C      integer MPI_COMM_WORLD
C      parameter (MPI_COMM_WORLD = 0)
C
C     We handle datatypes by putting the variables that hold them into
C     common.  This way, a Fortran program can directly use the various
C     datatypes and can even give them to C programs.
C
      integer MPI_INTEGER, MPI_REAL, MPI_DOUBLE_PRECISION, MPI_COMPLEX,
     $        MPI_LOGICAL, MPI_CHARACTER, MPI_BYTE
      common /mpipriv/ MPI_INTEGER, MPI_REAL, MPI_DOUBLE_PRECISION,
     $     MPI_COMPLEX, MPI_LOGICAL, MPI_CHARACTER, MPI_BYTE,
     $     MPI_COMM_WORLD
      
      INTEGER MPI_DOUBLE
      parameter (MPI_DOUBLE = 0)
C
C     On a CRAY, this needs to be a different type (128 bits).  Similar
C     changes are required for REAL, etc.
C
C      integer MPI_DOUBLE_PRECISION
C      parameter (MPI_DOUBLE_PRECISION = 0)
      integer MPI_ANY_SOURCE
      parameter (MPI_ANY_SOURCE = (-1))
      integer MPI_ANY_TAG
      parameter (MPI_ANY_TAG = (-1))
C
C     Define the default combination functions.  These are integers
C     because the Fortran binding requires that (integers are not
C     exchangable with functions in Fortran.  Try a DEC Alpha if you
C     don't believe us
C
      external MPI_SUM, MPI_MAX, MPI_MIN, MPI_PROD, MPI_LAND, MPI_BAND,
     $     MPI_LOR, MPI_BOR, MPI_LXOR, MPI_BXOR
