/*
 *  $Id: u_allreduce.c,v 1.8 1994/02/02 21:02:15 lusk Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#ifndef lint
static char vcid[] = "$Id: u_allreduce.c,v 1.8 1994/02/02 21:02:15 lusk Exp $";
#endif /* lint */

#include <mpi.h>
#include "coll.h"

/*@

MPI_User_allreduce - 

@*/
int MPI_User_allreduce ( sendbuf, recvbuf, count, datatype, op, comm )
void             *sendbuf;
void             *recvbuf;
int               count;
MPI_Datatype      datatype;
void            (*op)();
MPI_Comm          comm;
{
  int errno = MPI_SUCCESS;

  /* Check for invalid arguments */
  if ( ( (comm            == (MPI_Comm)0) && (errno = MPI_ERR_COMM_NULL) )  ||
       ( (comm->comm_type == MPIR_INTER)  && (errno = MPI_ERR_COMM_INTER) ) )
    return (errno); 
  
  /* Reduce to 0, then bcast */
  MPI_User_reduce ( sendbuf, recvbuf, count, datatype, op, 0, comm );
  MPI_Bcast ( recvbuf, count, datatype, 0, comm );

  return (errno);
}
