/*
 *  $Id: attr_freekey.c,v 1.5 1994/01/25 20:32:16 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include <mpi.h>

/*@

MPI_Attr_free_key - free attribute key for communicator cache attribute

@*/
int MPI_Attr_free_key ( keyval )
int keyval;
{
  MPIR_Attr_key *attr_key = (MPIR_Attr_key *)keyval;

  if ( keyval != 0 ) {
	if (attr_key->ref_count <= 1) 
	  FREE ( (MPIR_Attr_key *)keyval );
	else
	  attr_key->ref_count--;
  }
  return (MPI_SUCCESS);
}
