/*
 *  $Id: comm_rank.c,v 1.6 1994/01/28 17:31:49 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */


#ifndef lint
static char vcid[] = "$Id: comm_rank.c,v 1.6 1994/01/28 17:31:49 doss Exp $";
#endif /* lint */

#include <mpi.h>

/*@

MPI_Comm_rank - determine the rank of the calling process in the communicator

@*/
int MPI_Comm_rank ( comm, rank )
MPI_Comm comm;
int *rank;
{
  if (comm == (MPI_Comm)0) 
    (*rank) = MPI_UNDEFINED;
  else {
	if (comm->comm_type == MPIR_INTRA)
	  (*rank) = comm->group->local_rank;
	else
	  (*rank) = comm->local_group->local_rank;
  }
  return (MPI_SUCCESS);
}
