/*
 *  $Id: isend.c,v 1.9 1994/01/10 23:13:35 gropp Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */


#ifndef lint
static char vcid[] = "$Id: isend.c,v 1.9 1994/01/10 23:13:35 gropp Exp $";
#endif /* lint */

#include "mpi.h"

/*@
    MPI_Isend - Starts a nonblocking send
@*/
int MPI_Isend( start, count, datatype, dest, tag, comm, handle )
void             *start;
int              count;
MPI_Datatype     datatype;
int              dest;
int              tag;
MPI_Comm comm;
MPI_Comm_request *handle;
{
    if (dest != MPI_PROCNULL)
    {
	MPI_Comm_Init( handle, datatype, dest, tag, comm,
		      MPI_STANDARD, MPI_PERSISTENT);
	(*handle)->shandle.bufadd = start;
	(*handle)->shandle.count = count;
	MPI_Start( *handle );
    }
    else 
	*handle = 0;
    return MPI_OK;
}
