/*
 *  
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include <mpi.h>

/* This should convert a Fortran .true. to 1 and .false. to 0.  Must be
   defined for each system */

#define BOOL(f) ((f == 0) ? 0 : 1)
/*@

MPI_Make_cart - make a new communicator to which topology information
                has been attached

algorithm:
We ignore the periods and reorder info currently.

@*/
/*ARGSUSED*/
void mpi_make_cart_ ( comm_old, ndims, dims, periods, reorder, comm_cart, 
		      ierr ) 
int              *comm_old;
int              *ndims;     
int              *dims;     
int              *periods;
int              *reorder;
int              *comm_cart;
/* MPI_Comm *comm_cart; */
int              *ierr;
{
    MPI_Comm comm2;
    if (*comm_old == 0) comm2 = MPI_COMM_WORLD;
    else                comm2 = *(MPI_Comm*)comm_old;

    *ierr = MPI_Make_cart( comm2, *ndims, dims, periods, BOOL(*reorder), 
			   (MPI_Comm *) comm_cart ); 
}
